diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/general-template.php ./wordpress-3.4/wp-includes/general-template.php
*** ./wordpress-3.3.2/wp-includes/general-template.php	2011-11-30 22:51:35.000000000 -0600
--- ./wordpress-3.4/wp-includes/general-template.php	2012-06-04 11:04:54.000000000 -0500
***************
*** 1747,1761 ****
   * @return bool
   */
  function user_can_richedit() {
! 	global $wp_rich_edit, $is_gecko, $is_opera, $is_safari, $is_chrome, $is_iphone, $is_IE;
  
  	if ( !isset($wp_rich_edit) ) {
  		$wp_rich_edit = false;
  
! 		if ( get_user_option( 'rich_editing' ) == 'true' || !is_user_logged_in() ) { // default to 'true' for logged out users
  			if ( $is_safari ) {
! 				if ( !$is_iphone || ( preg_match( '!AppleWebKit/(\d+)!', $_SERVER['HTTP_USER_AGENT'], $match ) && intval($match[1]) >= 534 ) )
! 					$wp_rich_edit = true;
  			} elseif ( $is_gecko || $is_opera || $is_chrome || $is_IE ) {
  				$wp_rich_edit = true;
  			}
--- 1746,1759 ----
   * @return bool
   */
  function user_can_richedit() {
! 	global $wp_rich_edit, $is_gecko, $is_opera, $is_safari, $is_chrome, $is_IE;
  
  	if ( !isset($wp_rich_edit) ) {
  		$wp_rich_edit = false;
  
! 		if ( get_user_option( 'rich_editing' ) == 'true' || ! is_user_logged_in() ) { // default to 'true' for logged out users
  			if ( $is_safari ) {
! 				$wp_rich_edit = ! wp_is_mobile() || ( preg_match( '!AppleWebKit/(\d+)!', $_SERVER['HTTP_USER_AGENT'], $match ) && intval( $match[1] ) >= 534 );
  			} elseif ( $is_gecko || $is_opera || $is_chrome || $is_IE ) {
  				$wp_rich_edit = true;
  			}
***************
*** 1797,1803 ****
   * See http://core.trac.wordpress.org/ticket/19173 for more information.
   *
   * @see wp-includes/class-wp-editor.php
!  * @since 3.3
   *
   * @param string $content Initial content for the editor.
   * @param string $editor_id HTML ID attribute value for the textarea and TinyMCE. Can only be /[a-z]+/.
--- 1795,1801 ----
   * See http://core.trac.wordpress.org/ticket/19173 for more information.
   *
   * @see wp-includes/class-wp-editor.php
!  * @since 3.3.0
   *
   * @param string $content Initial content for the editor.
   * @param string $editor_id HTML ID attribute value for the textarea and TinyMCE. Can only be /[a-z]+/.
***************
*** 2037,2043 ****
  	wp_admin_css_color( 'classic', _x( 'Blue', 'admin color scheme' ), admin_url( 'css/colors-classic.css' ),
  		array( '#5589aa', '#cfdfe9', '#d1e5ee', '#eff8ff' ) );
  	wp_admin_css_color( 'fresh', _x( 'Gray', 'admin color scheme' ), admin_url( 'css/colors-fresh.css' ),
! 		array( '#7c7976', '#c6c6c6', '#e0e0e0', '#f1f1f1' ) );
  }
  
  /**
--- 2035,2041 ----
  	wp_admin_css_color( 'classic', _x( 'Blue', 'admin color scheme' ), admin_url( 'css/colors-classic.css' ),
  		array( '#5589aa', '#cfdfe9', '#d1e5ee', '#eff8ff' ) );
  	wp_admin_css_color( 'fresh', _x( 'Gray', 'admin color scheme' ), admin_url( 'css/colors-fresh.css' ),
! 		array( '#555', '#a0a0a0', '#ccc', '#f1f1f1' ) );
  }
  
  /**
***************
*** 2066,2072 ****
   * "Intelligently" decides to enqueue or to print the CSS file. If the
   * 'wp_print_styles' action has *not* yet been called, the CSS file will be
   * enqueued. If the wp_print_styles action *has* been called, the CSS link will
!  * be printed. Printing may be forced by passing TRUE as the $force_echo
   * (second) parameter.
   *
   * For backward compatibility with WordPress 2.3 calling method: If the $file
--- 2064,2070 ----
   * "Intelligently" decides to enqueue or to print the CSS file. If the
   * 'wp_print_styles' action has *not* yet been called, the CSS file will be
   * enqueued. If the wp_print_styles action *has* been called, the CSS link will
!  * be printed. Printing may be forced by passing true as the $force_echo
   * (second) parameter.
   *
   * For backward compatibility with WordPress 2.3 calling method: If the $file
***************
*** 2080,2086 ****
   *
   * @param string $file Optional. Style handle name or file name (without ".css" extension) relative
   * 	 to wp-admin/. Defaults to 'wp-admin'.
!  * @param bool $force_echo Optional.  Force the stylesheet link to be printed rather than enqueued.
   */
  function wp_admin_css( $file = 'wp-admin', $force_echo = false ) {
  	global $wp_styles;
--- 2078,2084 ----
   *
   * @param string $file Optional. Style handle name or file name (without ".css" extension) relative
   * 	 to wp-admin/. Defaults to 'wp-admin'.
!  * @param bool $force_echo Optional. Force the stylesheet link to be printed rather than enqueued.
   */
  function wp_admin_css( $file = 'wp-admin', $force_echo = false ) {
  	global $wp_styles;
***************
*** 2091,2097 ****
  	$handle = 0 === strpos( $file, 'css/' ) ? substr( $file, 4 ) : $file;
  
  	if ( $wp_styles->query( $handle ) ) {
! 		if ( $force_echo || did_action( 'wp_print_styles' ) ) // we already printed the style queue.  Print this one immediately
  			wp_print_styles( $handle );
  		else // Add to style queue
  			wp_enqueue_style( $handle );
--- 2089,2095 ----
  	$handle = 0 === strpos( $file, 'css/' ) ? substr( $file, 4 ) : $file;
  
  	if ( $wp_styles->query( $handle ) ) {
! 		if ( $force_echo || did_action( 'wp_print_styles' ) ) // we already printed the style queue. Print this one immediately
  			wp_print_styles( $handle );
  		else // Add to style queue
  			wp_enqueue_style( $handle );
***************
*** 2099,2105 ****
  	}
  
  	echo apply_filters( 'wp_admin_css', "<link rel='stylesheet' href='" . esc_url( wp_admin_css_uri( $file ) ) . "' type='text/css' />\n", $file );
! 	if ( is_rtl() )
  		echo apply_filters( 'wp_admin_css', "<link rel='stylesheet' href='" . esc_url( wp_admin_css_uri( "$file-rtl" ) ) . "' type='text/css' />\n", "$file-rtl" );
  }
  
--- 2097,2103 ----
  	}
  
  	echo apply_filters( 'wp_admin_css', "<link rel='stylesheet' href='" . esc_url( wp_admin_css_uri( $file ) ) . "' type='text/css' />\n", $file );
! 	if ( function_exists( 'is_rtl' ) && is_rtl() )
  		echo apply_filters( 'wp_admin_css', "<link rel='stylesheet' href='" . esc_url( wp_admin_css_uri( "$file-rtl" ) ) . "' type='text/css' />\n", "$file-rtl" );
  }
  
***************
*** 2107,2113 ****
   * Enqueues the default ThickBox js and css.
   *
   * If any of the settings need to be changed, this can be done with another js
!  * file similar to media-upload.js and theme-preview.js. That file should
   * require array('thickbox') to ensure it is loaded after.
   *
   * @since 2.5.0
--- 2105,2111 ----
   * Enqueues the default ThickBox js and css.
   *
   * If any of the settings need to be changed, this can be done with another js
!  * file similar to media-upload.js. That file should
   * require array('thickbox') to ensure it is loaded after.
   *
   * @since 2.5.0
***************
*** 2283,2287 ****
  
  	return $result;
  }
- 
- ?>
--- 2281,2283 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/http.php ./wordpress-3.4/wp-includes/http.php
*** ./wordpress-3.3.2/wp-includes/http.php	2011-09-03 11:02:41.000000000 -0500
--- ./wordpress-3.4/wp-includes/http.php	2012-05-15 13:46:03.000000000 -0500
***************
*** 197,203 ****
   * @since 3.2.0
   *
   * @param array  $capabilities Array of capabilities to test or a wp_remote_request() $args array.
!  * @param string $url Optional.  If given, will check if the URL requires SSL and adds that requirement to the capabilities array.
   *
   * @return bool
   */
--- 197,203 ----
   * @since 3.2.0
   *
   * @param array  $capabilities Array of capabilities to test or a wp_remote_request() $args array.
!  * @param string $url Optional. If given, will check if the URL requires SSL and adds that requirement to the capabilities array.
   *
   * @return bool
   */
***************
*** 222,224 ****
--- 222,301 ----
  
  	return (bool) $objFetchSite->_get_first_available_transport( $capabilities );
  }
+ 
+ /**
+  * Get the HTTP Origin of the current request.
+  *
+  * @since 3.4.0
+  *
+  * @return string URL of the origin. Empty string if no origin.
+  */
+ function get_http_origin() {
+ 	$origin = '';
+ 	if ( ! empty ( $_SERVER[ 'HTTP_ORIGIN' ] ) )
+ 		$origin = $_SERVER[ 'HTTP_ORIGIN' ];
+ 
+ 	return apply_filters( 'http_origin', $origin );
+ }
+ 
+ /**
+  * Retrieve list of allowed http origins.
+  *
+  * @since 3.4.0
+  *
+  * @return array Array of origin URLs.
+  */
+ function get_allowed_http_origins() {
+ 	$admin_origin = parse_url( admin_url() );
+ 	$home_origin = parse_url( home_url() );
+ 
+ 	// @todo preserve port?
+ 	$allowed_origins = array_unique( array(
+ 		'http://' . $admin_origin[ 'host' ],
+ 		'https://' . $admin_origin[ 'host' ],
+ 		'http://' . $home_origin[ 'host' ],
+ 		'https://' . $home_origin[ 'host' ],
+ 	) );
+ 
+ 	return apply_filters( 'allowed_http_origins' , $allowed_origins );
+ }
+ 
+ /**
+  * Determines if the http origin is an authorized one.
+  *
+  * @since 3.4.0
+  *
+  * @param string Origin URL. If not provided, the value of get_http_origin() is used.
+  * @return bool True if the origin is allowed. False otherwise.
+  */
+ function is_allowed_http_origin( $origin = null ) {
+ 	$origin_arg = $origin;
+ 
+ 	if ( null === $origin )
+ 		$origin = get_http_origin();
+ 
+ 	if ( $origin && ! in_array( $origin, get_allowed_http_origins() ) )
+ 		$origin = '';
+ 
+ 	return apply_filters( 'allowed_http_origin', $origin, $origin_arg );
+ }
+ 
+ /**
+  * Send Access-Control-Allow-Origin and related headers if the current request
+  * is from an allowed origin.
+  *
+  * @since 3.4.0
+  *
+  * @return bool|string Returns the origin URL if headers are sent. Returns false
+  * if headers are not sent.
+  */
+ function send_origin_headers() {
+ 	$origin = get_http_origin();
+ 	if ( ! is_allowed_http_origin( $origin ) )
+ 		return false;
+ 
+ 	@header( 'Access-Control-Allow-Origin: ' .  $origin );
+ 	@header( 'Access-Control-Allow-Credentials: true' );
+ 
+ 	return $origin;
+ }
\ No newline at end of file
Binary files ./wordpress-3.3.2/wp-includes/images/admin-bar-sprite-2x.png and ./wordpress-3.4/wp-includes/images/admin-bar-sprite-2x.png differ
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/admin-bar.dev.js ./wordpress-3.4/wp-includes/js/admin-bar.dev.js
*** ./wordpress-3.3.2/wp-includes/js/admin-bar.dev.js	2011-11-30 19:07:43.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/admin-bar.dev.js	2012-02-06 17:17:28.000000000 -0600
***************
*** 59,64 ****
--- 59,72 ----
  			target.siblings('.ab-sub-wrapper').find('.ab-item').each(refresh);
  		});
  
+ 		$('#wpadminbar').click( function(e) {
+ 			if ( e.target.id != 'wpadminbar' && e.target.id != 'wp-admin-bar-top-secondary' )
+ 				return;
+ 
+ 			e.preventDefault();
+ 			$('html, body').animate({ scrollTop: 0 }, 'fast');
+ 		});
+ 
  	});
  } else {
  	(function(d, w) {
***************
*** 178,183 ****
--- 186,225 ----
  				}
  			}
  			return false;
+ 		},
+ 
+ 		scrollToTop = function(t) {
+ 			var distance, speed, step, steps, timer, speed_step;
+ 
+ 			// Ensure that the #wpadminbar was the target of the click.
+ 			if ( t.id != 'wpadminbar' && t.id != 'wp-admin-bar-top-secondary' )
+ 				return;
+ 
+ 			distance    = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
+ 
+ 			if ( distance < 1 )
+ 				return;
+ 
+ 			speed_step = distance > 800 ? 130 : 100;
+ 			speed     = Math.min( 12, Math.round( distance / speed_step ) );
+ 			step      = distance > 800 ? Math.round( distance / 30  ) : Math.round( distance / 20  );
+ 			steps     = [];
+ 			timer     = 0;
+ 
+ 			// Animate scrolling to the top of the page by generating steps to
+ 			// the top of the page and shifting to each step at a set interval.
+ 			while ( distance ) {
+ 				distance -= step;
+ 				if ( distance < 0 )
+ 					distance = 0;
+ 				steps.push( distance );
+ 
+ 				setTimeout( function() {
+ 					window.scrollTo( 0, steps.shift() );
+ 				}, timer * speed );
+ 
+ 				timer++;
+ 			}
  		};
  
  		addEvent(w, 'load', function() {
***************
*** 198,203 ****
--- 240,249 ----
  				});
  
  				addEvent(aB, 'click', clickShortlink );
+ 
+ 				addEvent(aB, 'click', function(e) {
+ 					scrollToTop( e.target || e.srcElement );
+ 				});
  			}
  
  			if ( w.location.hash )
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/autosave.dev.js ./wordpress-3.4/wp-includes/js/autosave.dev.js
*** ./wordpress-3.3.2/wp-includes/js/autosave.dev.js	2011-11-29 12:06:56.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/autosave.dev.js	2011-12-13 17:45:31.000000000 -0600
***************
*** 229,235 ****
  
  function autosave_disable_buttons() {
  	jQuery(':button, :submit', '#submitpost').prop('disabled', true);
! 	// Re-enable 5 sec later.  Just gives autosave a head start to avoid collisions.
  	setTimeout(autosave_enable_buttons, 5000);
  }
  
--- 229,235 ----
  
  function autosave_disable_buttons() {
  	jQuery(':button, :submit', '#submitpost').prop('disabled', true);
! 	// Re-enable 5 sec later. Just gives autosave a head start to avoid collisions.
  	setTimeout(autosave_enable_buttons, 5000);
  }
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/customize-base.dev.js ./wordpress-3.4/wp-includes/js/customize-base.dev.js
*** ./wordpress-3.3.2/wp-includes/js/customize-base.dev.js	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/customize-base.dev.js	2012-06-08 17:59:48.000000000 -0500
***************
*** 0 ****
--- 1,586 ----
+ if ( typeof wp === 'undefined' )
+ 	var wp = {};
+ 
+ (function( exports, $ ){
+ 	var api, extend, ctor, inherits,
+ 		slice = Array.prototype.slice;
+ 
+ 	/* =====================================================================
+ 	 * Micro-inheritance - thank you, backbone.js.
+ 	 * ===================================================================== */
+ 
+ 	extend = function( protoProps, classProps ) {
+ 		var child = inherits( this, protoProps, classProps );
+ 		child.extend = this.extend;
+ 		return child;
+ 	};
+ 
+ 	// Shared empty constructor function to aid in prototype-chain creation.
+ 	ctor = function() {};
+ 
+ 	// Helper function to correctly set up the prototype chain, for subclasses.
+ 	// Similar to `goog.inherits`, but uses a hash of prototype properties and
+ 	// class properties to be extended.
+ 	inherits = function( parent, protoProps, staticProps ) {
+ 		var child;
+ 
+ 		// The constructor function for the new subclass is either defined by you
+ 		// (the "constructor" property in your `extend` definition), or defaulted
+ 		// by us to simply call `super()`.
+ 		if ( protoProps && protoProps.hasOwnProperty( 'constructor' ) ) {
+ 			child = protoProps.constructor;
+ 		} else {
+ 			child = function() {
+ 				// Storing the result `super()` before returning the value
+ 				// prevents a bug in Opera where, if the constructor returns
+ 				// a function, Opera will reject the return value in favor of
+ 				// the original object. This causes all sorts of trouble.
+ 				var result = parent.apply( this, arguments );
+ 				return result;
+ 			};
+ 		}
+ 
+ 		// Inherit class (static) properties from parent.
+ 		$.extend( child, parent );
+ 
+ 		// Set the prototype chain to inherit from `parent`, without calling
+ 		// `parent`'s constructor function.
+ 		ctor.prototype  = parent.prototype;
+ 		child.prototype = new ctor();
+ 
+ 		// Add prototype properties (instance properties) to the subclass,
+ 		// if supplied.
+ 		if ( protoProps )
+ 			$.extend( child.prototype, protoProps );
+ 
+ 		// Add static properties to the constructor function, if supplied.
+ 		if ( staticProps )
+ 			$.extend( child, staticProps );
+ 
+ 		// Correctly set child's `prototype.constructor`.
+ 		child.prototype.constructor = child;
+ 
+ 		// Set a convenience property in case the parent's prototype is needed later.
+ 		child.__super__ = parent.prototype;
+ 
+ 		return child;
+ 	};
+ 
+ 	api = {};
+ 
+ 	/* =====================================================================
+ 	 * Base class.
+ 	 * ===================================================================== */
+ 
+ 	api.Class = function( applicator, argsArray, options ) {
+ 		var magic, args = arguments;
+ 
+ 		if ( applicator && argsArray && api.Class.applicator === applicator ) {
+ 			args = argsArray;
+ 			$.extend( this, options || {} );
+ 		}
+ 
+ 		magic = this;
+ 		if ( this.instance ) {
+ 			magic = function() {
+ 				return magic.instance.apply( magic, arguments );
+ 			};
+ 
+ 			$.extend( magic, this );
+ 		}
+ 
+ 		magic.initialize.apply( magic, args );
+ 		return magic;
+ 	};
+ 
+ 	api.Class.applicator = {};
+ 
+ 	api.Class.prototype.initialize = function() {};
+ 
+ 	/*
+ 	 * Checks whether a given instance extended a constructor.
+ 	 *
+ 	 * The magic surrounding the instance parameter causes the instanceof
+ 	 * keyword to return inaccurate results; it defaults to the function's
+ 	 * prototype instead of the constructor chain. Hence this function.
+ 	 */
+ 	api.Class.prototype.extended = function( constructor ) {
+ 		var proto = this;
+ 
+ 		while ( typeof proto.constructor !== 'undefined' ) {
+ 			if ( proto.constructor === constructor )
+ 				return true;
+ 			if ( typeof proto.constructor.__super__ === 'undefined' )
+ 				return false;
+ 			proto = proto.constructor.__super__;
+ 		}
+ 		return false;
+ 	};
+ 
+ 	api.Class.extend = extend;
+ 
+ 	/* =====================================================================
+ 	 * Events mixin.
+ 	 * ===================================================================== */
+ 
+ 	api.Events = {
+ 		trigger: function( id ) {
+ 			if ( this.topics && this.topics[ id ] )
+ 				this.topics[ id ].fireWith( this, slice.call( arguments, 1 ) );
+ 			return this;
+ 		},
+ 
+ 		bind: function( id, callback ) {
+ 			this.topics = this.topics || {};
+ 			this.topics[ id ] = this.topics[ id ] || $.Callbacks();
+ 			this.topics[ id ].add.apply( this.topics[ id ], slice.call( arguments, 1 ) );
+ 			return this;
+ 		},
+ 
+ 		unbind: function( id, callback ) {
+ 			if ( this.topics && this.topics[ id ] )
+ 				this.topics[ id ].remove.apply( this.topics[ id ], slice.call( arguments, 1 ) );
+ 			return this;
+ 		}
+ 	};
+ 
+ 	/* =====================================================================
+ 	 * Observable values that support two-way binding.
+ 	 * ===================================================================== */
+ 
+ 	api.Value = api.Class.extend({
+ 		initialize: function( initial, options ) {
+ 			this._value = initial; // @todo: potentially change this to a this.set() call.
+ 			this.callbacks = $.Callbacks();
+ 
+ 			$.extend( this, options || {} );
+ 
+ 			this.set = $.proxy( this.set, this );
+ 		},
+ 
+ 		/*
+ 		 * Magic. Returns a function that will become the instance.
+ 		 * Set to null to prevent the instance from extending a function.
+ 		 */
+ 		instance: function() {
+ 			return arguments.length ? this.set.apply( this, arguments ) : this.get();
+ 		},
+ 
+ 		get: function() {
+ 			return this._value;
+ 		},
+ 
+ 		set: function( to ) {
+ 			var from = this._value;
+ 
+ 			to = this._setter.apply( this, arguments );
+ 			to = this.validate( to );
+ 
+ 			// Bail if the sanitized value is null or unchanged.
+ 			if ( null === to || this._value === to )
+ 				return this;
+ 
+ 			this._value = to;
+ 
+ 			this.callbacks.fireWith( this, [ to, from ] );
+ 
+ 			return this;
+ 		},
+ 
+ 		_setter: function( to ) {
+ 			return to;
+ 		},
+ 
+ 		setter: function( callback ) {
+ 			var from = this.get();
+ 			this._setter = callback;
+ 			// Temporarily clear value so setter can decide if it's valid.
+ 			this._value = null;
+ 			this.set( from );
+ 			return this;
+ 		},
+ 
+ 		resetSetter: function() {
+ 			this._setter = this.constructor.prototype._setter;
+ 			this.set( this.get() );
+ 			return this;
+ 		},
+ 
+ 		validate: function( value ) {
+ 			return value;
+ 		},
+ 
+ 		bind: function( callback ) {
+ 			this.callbacks.add.apply( this.callbacks, arguments );
+ 			return this;
+ 		},
+ 
+ 		unbind: function( callback ) {
+ 			this.callbacks.remove.apply( this.callbacks, arguments );
+ 			return this;
+ 		},
+ 
+ 		link: function() { // values*
+ 			var set = this.set;
+ 			$.each( arguments, function() {
+ 				this.bind( set );
+ 			});
+ 			return this;
+ 		},
+ 
+ 		unlink: function() { // values*
+ 			var set = this.set;
+ 			$.each( arguments, function() {
+ 				this.unbind( set );
+ 			});
+ 			return this;
+ 		},
+ 
+ 		sync: function() { // values*
+ 			var that = this;
+ 			$.each( arguments, function() {
+ 				that.link( this );
+ 				this.link( that );
+ 			});
+ 			return this;
+ 		},
+ 
+ 		unsync: function() { // values*
+ 			var that = this;
+ 			$.each( arguments, function() {
+ 				that.unlink( this );
+ 				this.unlink( that );
+ 			});
+ 			return this;
+ 		}
+ 	});
+ 
+ 	/* =====================================================================
+ 	 * A collection of observable values.
+ 	 * ===================================================================== */
+ 
+ 	api.Values = api.Class.extend({
+ 		defaultConstructor: api.Value,
+ 
+ 		initialize: function( options ) {
+ 			$.extend( this, options || {} );
+ 
+ 			this._value = {};
+ 			this._deferreds = {};
+ 		},
+ 
+ 		instance: function( id ) {
+ 			if ( arguments.length === 1 )
+ 				return this.value( id );
+ 
+ 			return this.when.apply( this, arguments );
+ 		},
+ 
+ 		value: function( id ) {
+ 			return this._value[ id ];
+ 		},
+ 
+ 		has: function( id ) {
+ 			return typeof this._value[ id ] !== 'undefined';
+ 		},
+ 
+ 		add: function( id, value ) {
+ 			if ( this.has( id ) )
+ 				return this.value( id );
+ 
+ 			this._value[ id ] = value;
+ 			value.parent = this;
+ 			if ( value.extended( api.Value ) )
+ 				value.bind( this._change );
+ 
+ 			this.trigger( 'add', value );
+ 
+ 			if ( this._deferreds[ id ] )
+ 				this._deferreds[ id ].resolve();
+ 
+ 			return this._value[ id ];
+ 		},
+ 
+ 		create: function( id ) {
+ 			return this.add( id, new this.defaultConstructor( api.Class.applicator, slice.call( arguments, 1 ) ) );
+ 		},
+ 
+ 		each: function( callback, context ) {
+ 			context = typeof context === 'undefined' ? this : context;
+ 
+ 			$.each( this._value, function( key, obj ) {
+ 				callback.call( context, obj, key );
+ 			});
+ 		},
+ 
+ 		remove: function( id ) {
+ 			var value;
+ 
+ 			if ( this.has( id ) ) {
+ 				value = this.value( id );
+ 				this.trigger( 'remove', value );
+ 				if ( value.extended( api.Value ) )
+ 					value.unbind( this._change );
+ 				delete value.parent;
+ 			}
+ 
+ 			delete this._value[ id ];
+ 			delete this._deferreds[ id ];
+ 		},
+ 
+ 		/**
+ 		 * Runs a callback once all requested values exist.
+ 		 *
+ 		 * when( ids*, [callback] );
+ 		 *
+ 		 * For example:
+ 		 *     when( id1, id2, id3, function( value1, value2, value3 ) {} );
+ 		 *
+ 		 * @returns $.Deferred.promise();
+ 		 */
+ 		when: function() {
+ 			var self = this,
+ 				ids  = slice.call( arguments ),
+ 				dfd  = $.Deferred();
+ 
+ 			// If the last argument is a callback, bind it to .done()
+ 			if ( $.isFunction( ids[ ids.length - 1 ] ) )
+ 				dfd.done( ids.pop() );
+ 
+ 			$.when.apply( $, $.map( ids, function( id ) {
+ 				if ( self.has( id ) )
+ 					return;
+ 
+ 				return self._deferreds[ id ] = self._deferreds[ id ] || $.Deferred();
+ 			})).done( function() {
+ 				var values = $.map( ids, function( id ) {
+ 						return self( id );
+ 					});
+ 
+ 				// If a value is missing, we've used at least one expired deferred.
+ 				// Call Values.when again to generate a new deferred.
+ 				if ( values.length !== ids.length ) {
+ 					// ids.push( callback );
+ 					self.when.apply( self, ids ).done( function() {
+ 						dfd.resolveWith( self, values );
+ 					});
+ 					return;
+ 				}
+ 
+ 				dfd.resolveWith( self, values );
+ 			});
+ 
+ 			return dfd.promise();
+ 		},
+ 
+ 		_change: function() {
+ 			this.parent.trigger( 'change', this );
+ 		}
+ 	});
+ 
+ 	$.extend( api.Values.prototype, api.Events );
+ 
+ 	/* =====================================================================
+ 	 * An observable value that syncs with an element.
+ 	 *
+ 	 * Handles inputs, selects, and textareas by default.
+ 	 * ===================================================================== */
+ 
+ 	api.ensure = function( element ) {
+ 		return typeof element == 'string' ? $( element ) : element;
+ 	};
+ 
+ 	api.Element = api.Value.extend({
+ 		initialize: function( element, options ) {
+ 			var self = this,
+ 				synchronizer = api.Element.synchronizer.html,
+ 				type, update, refresh;
+ 
+ 			this.element = api.ensure( element );
+ 			this.events = '';
+ 
+ 			if ( this.element.is('input, select, textarea') ) {
+ 				this.events += 'change';
+ 				synchronizer = api.Element.synchronizer.val;
+ 
+ 				if ( this.element.is('input') ) {
+ 					type = this.element.prop('type');
+ 					if ( api.Element.synchronizer[ type ] )
+ 						synchronizer = api.Element.synchronizer[ type ];
+ 					if ( 'text' === type || 'password' === type )
+ 						this.events += ' keyup';
+ 				} else if ( this.element.is('textarea') ) {
+ 					this.events += ' keyup';
+ 				}
+ 			}
+ 
+ 			api.Value.prototype.initialize.call( this, null, $.extend( options || {}, synchronizer ) );
+ 			this._value = this.get();
+ 
+ 			update  = this.update;
+ 			refresh = this.refresh;
+ 
+ 			this.update = function( to ) {
+ 				if ( to !== refresh.call( self ) )
+ 					update.apply( this, arguments );
+ 			};
+ 			this.refresh = function() {
+ 				self.set( refresh.call( self ) );
+ 			};
+ 
+ 			this.bind( this.update );
+ 			this.element.bind( this.events, this.refresh );
+ 		},
+ 
+ 		find: function( selector ) {
+ 			return $( selector, this.element );
+ 		},
+ 
+ 		refresh: function() {},
+ 
+ 		update: function() {}
+ 	});
+ 
+ 	api.Element.synchronizer = {};
+ 
+ 	$.each( [ 'html', 'val' ], function( i, method ) {
+ 		api.Element.synchronizer[ method ] = {
+ 			update: function( to ) {
+ 				this.element[ method ]( to );
+ 			},
+ 			refresh: function() {
+ 				return this.element[ method ]();
+ 			}
+ 		};
+ 	});
+ 
+ 	api.Element.synchronizer.checkbox = {
+ 		update: function( to ) {
+ 			this.element.prop( 'checked', to );
+ 		},
+ 		refresh: function() {
+ 			return this.element.prop( 'checked' );
+ 		}
+ 	};
+ 
+ 	api.Element.synchronizer.radio = {
+ 		update: function( to ) {
+ 			this.element.filter( function() {
+ 				return this.value === to;
+ 			}).prop( 'checked', true );
+ 		},
+ 		refresh: function() {
+ 			return this.element.filter( ':checked' ).val();
+ 		}
+ 	};
+ 
+ 	/* =====================================================================
+ 	 * Messenger for postMessage.
+ 	 * ===================================================================== */
+ 
+ 	$.support.postMessage = !! window.postMessage;
+ 
+ 	api.Messenger = api.Class.extend({
+ 		add: function( key, initial, options ) {
+ 			return this[ key ] = new api.Value( initial, options );
+ 		},
+ 
+ 		/**
+ 		 * Initialize Messenger.
+ 		 *
+ 		 * @param  {object} params        Parameters to configure the messenger.
+ 		 *         {string} .url          The URL to communicate with.
+ 		 *         {window} .targetWindow The window instance to communicate with. Default window.parent.
+ 		 *         {string} .channel      If provided, will send the channel with each message and only accept messages a matching channel.
+ 		 * @param  {object} options       Extend any instance parameter or method with this object.
+ 		 */
+ 		initialize: function( params, options ) {
+ 			// Target the parent frame by default, but only if a parent frame exists.
+ 			var defaultTarget = window.parent == window ? null : window.parent;
+ 
+ 			$.extend( this, options || {} );
+ 
+ 			this.add( 'channel', params.channel );
+ 			this.add( 'url', params.url || '' );
+ 			this.add( 'targetWindow', params.targetWindow || defaultTarget );
+ 			this.add( 'origin', this.url() ).link( this.url ).setter( function( to ) {
+ 				return to.replace( /([^:]+:\/\/[^\/]+).*/, '$1' );
+ 			});
+ 
+ 			// Since we want jQuery to treat the receive function as unique
+ 			// to this instance, we give the function a new guid.
+ 			//
+ 			// This will prevent every Messenger's receive function from being
+ 			// unbound when calling $.off( 'message', this.receive );
+ 			this.receive = $.proxy( this.receive, this );
+ 			this.receive.guid = $.guid++;
+ 
+ 			$( window ).on( 'message', this.receive );
+ 		},
+ 
+ 		destroy: function() {
+ 			$( window ).off( 'message', this.receive );
+ 		},
+ 
+ 		receive: function( event ) {
+ 			var message;
+ 
+ 			event = event.originalEvent;
+ 
+ 			if ( ! this.targetWindow() )
+ 				return;
+ 
+ 			// Check to make sure the origin is valid.
+ 			if ( this.origin() && event.origin !== this.origin() )
+ 				return;
+ 
+ 			message = JSON.parse( event.data );
+ 
+ 			// Check required message properties.
+ 			if ( ! message || ! message.id || typeof message.data === 'undefined' )
+ 				return;
+ 
+ 			// Check if channel names match.
+ 			if ( ( message.channel || this.channel() ) && this.channel() !== message.channel )
+ 				return;
+ 
+ 			this.trigger( message.id, message.data );
+ 		},
+ 
+ 		send: function( id, data ) {
+ 			var message;
+ 
+ 			data = typeof data === 'undefined' ? null : data;
+ 
+ 			if ( ! this.url() || ! this.targetWindow() )
+ 				return;
+ 
+ 			message = { id: id, data: data };
+ 			if ( this.channel() )
+ 				message.channel = this.channel();
+ 
+ 			this.targetWindow().postMessage( JSON.stringify( message ), this.origin() );
+ 		}
+ 	});
+ 
+ 	// Add the Events mixin to api.Messenger.
+ 	$.extend( api.Messenger.prototype, api.Events );
+ 
+ 	/* =====================================================================
+ 	 * Core customize object.
+ 	 * ===================================================================== */
+ 
+ 	api = $.extend( new api.Values(), api );
+ 	api.get = function() {
+ 		var result = {};
+ 
+ 		this.each( function( obj, key ) {
+ 			result[ key ] = obj.get();
+ 		});
+ 
+ 		return result;
+ 	};
+ 
+ 	// Expose the API to the world.
+ 	exports.customize = api;
+ })( wp, jQuery );
